# -*- coding: utf-8 -*-
"""mergesortDList.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1_XTk43tPgsnr4ENSaTsyP5AWuyfNmUCR

Implementa el algoritmo mergesort que recibe una lista doblemente enlazada y devuelve la lista ordenada
"""

if 'google.colab' in str(get_ipython()):
    #If your run from Spyder, please uncomment:
    from google.colab import files
    #search the file in your local disk: carga binarytree.py
    files.upload()

from dlist import DList

class DList2(DList):


    def __eq__(self,other):
        """returns True if self and other contains the same elements and in the same order. Otherwise,
        it returns False"""
        if other==None or len(self)!=len(other):
            return False
        
        nodeSelf=self._head
        nodeOther=other._head
        while nodeSelf:
            if nodeSelf.elem!=nodeOther.elem:
                return False
            nodeSelf=nodeSelf.next
            nodeOther=nodeOther.next
            
        return True


    def split2(self):
        """splits the list in a half and returns the two parts as two doubly linked lists
        Complexity O(n)"""

        i=0
        half=self._head
        while i<len(self)//2:
            half=half.next
            i+=1

        left=DList2()
        if half!=self._head:
            left._head=self._head
            left._tail=half.prev
            left._tail.next=None
            left._size=len(self)//2

        right=DList2()
        right._head=half
        if right._head:
            right._head.prev=None
        right._tail=self._tail
        right._size=len(self)//2
        if len(self)%2!=0:
            right._size+=1

        return left, right

    def split(self):
        """splits the list in a half and returns the two parts as two doubly linked lists
        Complexity O(n)"""

        left=DList2()
        node=self._head
        for i in range(len(self)//2):
            left.addLast(node.elem)
            node=node.next

        right=DList2()
        for i in range(len(self)//2,len(self)):
            right.addLast(node.elem)
            node=node.next

        return left, right

    @staticmethod
    def merge(list1, list2):
        newList=DList()
		
        node1=list1._head
        node2=list2._head
        
        while node1 and node2:
            if node1.elem <= node2.elem:
                newList.addLast(node1.elem)
                node1=node1.next
            else:
                newList.addLast(node2.elem)
                node2=node2.next
		
        while node1:
            newList.addLast(node1.elem)
            node1=node1.next
		
        while node2:
            newList.addLast(node2.elem)
            node2=node2.next
		

        return newList
  
def mergesort(l):
    if l==None:
        return None
    if len(l)<=1:
        return l

    left,right=l.split()
    sorted1=mergesort(left)
    sorted2=mergesort(right)

    return DList2.merge(sorted1,sorted2)


input=DList2()
for x in range(6):
    input.addLast(random.randint(0,25))

print('Input: ', input)

print("after mergesort:", mergesort(input))

import unittest #package that contains the classes t
import random

class Test(unittest.TestCase):
    def test1_split(self):
        print('test1_split: emptylist')
        input=DList2()
        resultLeft,resultRight=input.split()
        requiredLeft=DList2()
        requiredRight=DList2()

        self.assertEqual(resultLeft,requiredLeft)
        self.assertEqual(resultRight,requiredRight)

        print('test1_split was OK')

    def test2_split(self):
        print('test2_split: size 1')
        input=DList2()
        input.addLast(1)
        resultLeft,resultRight=input.split()

        expectedLeft=DList2()
        expectedRight=DList2()
        expectedRight.addLast(1)

        self.assertEqual(resultLeft,expectedLeft)
        self.assertEqual(resultRight,expectedRight)

        print('test2_split was OK')

    def test3_split(self):
        print('test3_split: size even')
        input=DList2()
        expectedLeft=DList2()
        expectedRight=DList2()
        array=[10, 20, 5, 1, 5, 20, 20, 11, 20, 3]
        for i,x in enumerate(array):
            input.addLast(x)
            if i < len(array)//2:
                expectedLeft.addLast(x)
            else:
                expectedRight.addLast(x)

        

        resultLeft,resultRight=input.split()

        self.assertEqual(resultLeft,expectedLeft)
        self.assertEqual(resultRight,expectedRight)

        print('test3_split was OK')



    def test4_split(self):
        print('test4_split: size odd')
        input=DList2()
        expectedLeft=DList2()
        expectedRight=DList2()
        array=[10, 20, 5, 1, 5, 20, 20, 11, 20, 3, 33]
        for i,x in enumerate(array):
            input.addLast(x)
            if i < len(array)//2:
                expectedLeft.addLast(x)
            else:
                expectedRight.addLast(x)

        

        resultLeft,resultRight=input.split()

        self.assertEqual(resultLeft,expectedLeft)
        self.assertEqual(resultRight,expectedRight)

        print('test4_split was OK')


    def test5_merge(self):
        print('test5_merge')
        sorted1=DList2()
        array1=[3,5, 22, 31, 43]
        expected=DList2()
        for x in array1:
            sorted1.addLast(x)
            
        sorted2=DList2()
        array2=[2,5,10, 20, 21, 22, 33]
        for x in array2:
            sorted2.addLast(x)
        
        expected=DList2()


        array=[2,3, 5, 5, 10, 20, 21, 22, 22, 31, 33, 43]
        for x in array:
            expected.addLast(x)
        result=DList2.merge(sorted1,sorted2)
        #print(result)
        self.assertEqual(result,expected)

        print('test5_merge was OK')

if 'google.colab' in str(get_ipython()):
    #For google colab
    unittest.main(argv=['first-arg-is-ignored'], exit=False)
else:
    #Spyder:
    if __name__ == '__main__':
        unittest.main()